SystemOrganization addCategory: #FuelProgressUpdate!
SystemOrganization addCategory: #'FuelProgressUpdate-Tests'!

!FLSerializer methodsFor: '*FuelProgressUpdate-configuring' stamp: 'MartinDias 5/7/2012 20:23'!
showProgress

	serializationFactory := [:anObject :anEncoder | 
		FLSerializationProgressHandler newInstanceDo: [:aHandler |
			(FLProgressSerialization 
				with: anEncoder
				root: anObject 
				analyzer: self analyzer showProgress)
				progressHandler: aHandler;
				run;
				yourself ] ]! !

FLAnalysis subclass: #FLProgressAnalysis
	instanceVariableNames: 'progressHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelProgressUpdate'!

!FLProgressAnalysis commentStamp: '<historical>' prior: 0!
I am a subclass which notifies progress.
!

!FLProgressAnalysis methodsFor: 'mapping' stamp: 'MartinDias 5/31/2011 18:44'!
mapAndTrace: anObject

	progressHandler analyzedObject: anObject. 
	super mapAndTrace: anObject.! !

!FLProgressAnalysis methodsFor: 'accessing' stamp: 'MartinDias 5/1/2012 17:46'!
progressCheckpoints
	
	^ root isCollection 
		ifTrue: [ root asIdentitySet ]
		ifFalse: [ IdentitySet with: root ]! !

!FLProgressAnalysis methodsFor: 'accessing' stamp: 'MartinDias 9/13/2011 18:22'!
progressHandler
	^ progressHandler! !

!FLProgressAnalysis methodsFor: 'accessing' stamp: 'MartinDias 9/13/2011 18:22'!
progressHandler: anObject
	progressHandler := anObject! !

!FLProgressAnalysis methodsFor: 'analyzing' stamp: 'MartinDias 5/1/2012 17:45'!
run

	progressHandler analysisBegin: self progressCheckpoints.
	super run! !

FLSerializationTest subclass: #FLProgressTest
	instanceVariableNames: 'hasShownProgressOnSerialize hasShownProgressOnMaterialize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelProgressUpdate-Tests'!

!FLProgressTest methodsFor: 'running' stamp: 'MartinDias 5/8/2012 00:39'!
materialization

	| result hasShownProgress |
	hasShownProgress := false.

	result := [ super materialization ]
		on: ProgressInitiationException
		do: [ :ex | 
			ex sendNotificationsTo: [ :min :max :curr | 
				hasShownProgress := true ] ].

	self assert: hasShownProgress.
	^ result
	! !

!FLProgressTest methodsFor: 'running' stamp: 'MartinDias 5/8/2012 00:38'!
serialize: anObject

	| hasShownProgress result |
	hasShownProgress := false.
	
	result := [ super serialize: anObject ]
		on: ProgressInitiationException
		do: [ :ex | 
			ex sendNotificationsTo: [ :min :max :curr | 
				hasShownProgress := true ] ].
	
	self assert: hasShownProgress.
	^ result! !

!FLProgressTest methodsFor: 'running' stamp: 'MartinDias 5/8/2012 00:37'!
setUpMaterializer
	super setUpMaterializer.
	self materializer showProgress.! !

!FLProgressTest methodsFor: 'running' stamp: 'MartinDias 5/8/2012 00:37'!
setUpSerializer
	super setUpSerializer.
	self serializer showProgress.! !

!FLProgressTest methodsFor: 'tests' stamp: 'MartinDias 5/7/2012 19:56'!
testArray

	self resultOfSerializeAndMaterialize: (1 to: 1<<15) asArray! !

!FLProgressTest methodsFor: 'tests' stamp: 'MartinDias 5/7/2012 19:56'!
testIdentitySet

	self resultOfSerializeAndMaterialize: (1 to: 1<<15) asIdentitySet! !

!FLProgressTest methodsFor: 'tests' stamp: 'MartinDias 5/7/2012 19:52'!
testInteger

	self resultOfSerializeAndMaterialize: 1! !

!FLAnalyzer methodsFor: '*FuelProgressUpdate-configuring' stamp: 'MartinDias 5/7/2012 20:22'!
showProgress

	analysisFactory := [:anObject | 
		FLAnalysisProgressHandler newInstanceDo: [:aHandler |
			(FLProgressAnalysis 
				newWith: self firstInMapperChain 
				root: anObject)
				progressHandler: aHandler;
				run;
				yourself ] ]! !

FLMaterialization subclass: #FLProgressMaterialization
	instanceVariableNames: 'progressHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelProgressUpdate'!

!FLProgressMaterialization commentStamp: '<historical>' prior: 0!
I am a subclass which notifies progress.
!

!FLProgressMaterialization methodsFor: 'private' stamp: 'MartinDias 9/12/2011 02:55'!
clusterInstancesStep

	super clusterInstancesStep.
	self progressHandler materializedCluster.! !

!FLProgressMaterialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 19:00'!
headerStep

	super headerStep.
	self progressHandler materializationBegin: self objects capacity.! !

!FLProgressMaterialization methodsFor: 'accessing' stamp: 'MartinDias 4/28/2011 16:04'!
progressHandler
	^ progressHandler! !

!FLProgressMaterialization methodsFor: 'accessing' stamp: 'MartinDias 4/28/2011 16:04'!
progressHandler: anObject
	progressHandler := anObject! !

!FLProgressMaterialization methodsFor: 'accessing' stamp: 'MartinDias 8/29/2011 16:26'!
registerAll: aCollection
	
	super registerAll: aCollection.
	self progressHandler materializedObjects: aCollection.! !

!FLProgressMaterialization methodsFor: 'materializing' stamp: 'MartinDias 9/12/2011 03:02'!
run

	super run.
	self progressHandler materializationEnd.! !

!FLMaterializer methodsFor: '*FuelProgressUpdate-configuring' stamp: 'MartinDias 5/7/2012 20:23'!
showProgress

	materializationFactory := [:aDecoder | 
		FLMaterializationProgressHandler newInstanceDo: [:aHandler |
			(FLProgressMaterialization 
				with: aDecoder)
				progressHandler: aHandler;
				run;
				yourself ] ]! !

Object subclass: #FLProgressHandler
	instanceVariableNames: 'progressListener'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelProgressUpdate'!

!FLProgressHandler commentStamp: '<historical>' prior: 0!
My job is to estimate a percentage of completeness of a run.!

FLProgressHandler subclass: #FLAnalysisProgressHandler
	instanceVariableNames: 'remainingCheckpoints totalNumberOfCheckpoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelProgressUpdate'!

!FLAnalysisProgressHandler commentStamp: '<historical>' prior: 0!
My job is to estimate a percentage of completeness of an analysis run. See FLProgressAnalysis.!

!FLAnalysisProgressHandler classSide methodsFor: 'accessing' stamp: 'MartinDias 9/13/2011 19:42'!
title
	^'Analyzing graph'! !

!FLAnalysisProgressHandler methodsFor: 'progress handling' stamp: 'MartinDias 5/7/2012 16:07'!
analysisBegin: aCollection

	remainingCheckpoints := IdentitySet newFrom: aCollection.
	totalNumberOfCheckpoints := remainingCheckpoints size.
	progressListener value: 0! !

!FLAnalysisProgressHandler methodsFor: 'progress handling' stamp: 'MartinDias 5/7/2012 16:07'!
analyzedObject: anObject 

	remainingCheckpoints
		remove: anObject
		ifAbsent: [ ^self ].
	progressListener value: self progress.! !

!FLAnalysisProgressHandler methodsFor: 'private' stamp: 'MartinDias 5/7/2012 19:19'!
progress

	^ 100 * (1 - (remainingCheckpoints size / totalNumberOfCheckpoints))! !

FLProgressHandler subclass: #FLMaterializationProgressHandler
	instanceVariableNames: 'materializingEstimatedPercentage numberOfObjectsAlreadyMaterialized numberOfObjectsToMaterialize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelProgressUpdate'!

!FLMaterializationProgressHandler commentStamp: 'MartinDias 5/7/2012 14:35' prior: 0!
My job is to estimate a percentage of completeness of a materialization run. See FLProgressMaterialization.!

!FLMaterializationProgressHandler classSide methodsFor: 'accessing' stamp: 'MartinDias 9/13/2011 16:15'!
title
	^'Reading from stream'! !

!FLMaterializationProgressHandler methodsFor: 'accessing' stamp: 'MartinDias 5/7/2012 16:08'!
initialize

	super initialize.
	materializingEstimatedPercentage := 90.! !

!FLMaterializationProgressHandler methodsFor: 'progress handling' stamp: 'MartinDias 5/7/2012 16:07'!
materializationBegin: objectCount

	numberOfObjectsAlreadyMaterialized := 0.
	numberOfObjectsToMaterialize := objectCount.
	progressListener value: 0! !

!FLMaterializationProgressHandler methodsFor: 'progress handling' stamp: 'MartinDias 5/7/2012 16:07'!
materializationEnd
	
	progressListener value: 100! !

!FLMaterializationProgressHandler methodsFor: 'progress handling' stamp: 'MartinDias 5/7/2012 16:07'!
materializedCluster
	
	progressListener value: self progress! !

!FLMaterializationProgressHandler methodsFor: 'progress handling' stamp: 'MartinDias 4/28/2011 16:41'!
materializedObjects: aCollection 

	numberOfObjectsAlreadyMaterialized := numberOfObjectsAlreadyMaterialized + aCollection size! !

!FLMaterializationProgressHandler methodsFor: 'private' stamp: 'MartinDias 5/1/2012 18:07'!
progress

	^ materializingEstimatedPercentage * numberOfObjectsAlreadyMaterialized / numberOfObjectsToMaterialize! !

!FLProgressHandler classSide methodsFor: 'instance creation' stamp: 'MartinDias 5/7/2012 16:04'!
newInstanceDo: aBlock

	| result |
	self title 
		displayProgressFrom: 0 to: 100 
		during: [ :aProgressListener | 
			result := aBlock value: (self newUpdatingProgressTo: aProgressListener) ].
	^result! !

!FLProgressHandler classSide methodsFor: 'instance creation' stamp: 'MartinDias 5/7/2012 16:04'!
newUpdatingProgressTo: aProgressListener

	^self basicNew
		initializeWith: aProgressListener;
		yourself.! !

!FLProgressHandler classSide methodsFor: 'accessing' stamp: 'MartinDias 5/7/2012 16:05'!
title

	self subclassResponsibility  ! !

!FLProgressHandler methodsFor: 'initialize-release' stamp: 'MartinDias 5/7/2012 16:05'!
initializeWith: aProgressListener

	self initialize.
	progressListener := aProgressListener! !

FLProgressHandler subclass: #FLSerializationProgressHandler
	instanceVariableNames: 'numberOfObjectsToSerialize numberOfObjectsAlreadySerialized'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelProgressUpdate'!

!FLSerializationProgressHandler commentStamp: 'MartinDias 5/7/2012 14:35' prior: 0!
My job is to estimate a percentage of completeness of a serialization run. See FLProgressSerialization.!

!FLSerializationProgressHandler classSide methodsFor: 'accessing' stamp: 'MartinDias 9/13/2011 19:39'!
title
	^'Writing to stream'! !

!FLSerializationProgressHandler methodsFor: 'private' stamp: 'MartinDias 5/7/2012 16:10'!
progress

	^ 100 * numberOfObjectsAlreadySerialized / numberOfObjectsToSerialize! !

!FLSerializationProgressHandler methodsFor: 'progress handling' stamp: 'MartinDias 5/7/2012 16:10'!
serializationBegin: clusteredObjects and: objectCount

	numberOfObjectsToSerialize := objectCount.
	numberOfObjectsAlreadySerialized := 0.
	progressListener value: self progress.! !

!FLSerializationProgressHandler methodsFor: 'progress handling' stamp: 'MartinDias 5/7/2012 16:09'!
serializationEnd

	progressListener value: 100.! !

!FLSerializationProgressHandler methodsFor: 'progress handling' stamp: 'MartinDias 5/7/2012 16:10'!
serializedCluster: aCluster

	numberOfObjectsAlreadySerialized := numberOfObjectsAlreadySerialized + aCluster objects size.
	progressListener value: self progress.! !

Object subclass: #ManifestFuelProgressUpdate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelProgressUpdate'!

!ManifestFuelProgressUpdate classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:08'!
rejectClasses
^ #()! !

!ManifestFuelProgressUpdate classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:08'!
rejectRules
^ #()! !

!ManifestFuelProgressUpdate classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:26'!
ruleCodeCruftLeftInMethodsRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLProgressSerialization class'' selector: #defaultProgressBarFactory isMetaSide: true)' #'2012-04-21T17:26:41.162000001+02:00') )! !

!ManifestFuelProgressUpdate classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:34'!
ruleInconsistentMethodClassificationRuleV1TruePositive
^ #(#('(RGMethodDefinition className: ''FLProgressSerialization'' selector: #clusterInstancesStepOf: isMetaSide: false)' #'2012-04-21T17:34:52.439000001+02:00') #('(RGMethodDefinition className: ''FLProgressSerialization'' selector: #headerStep isMetaSide: false)' #'2012-04-21T17:34:52.488000001+02:00') #('(RGMethodDefinition className: ''FLProgressAnalysis'' selector: #run isMetaSide: false)' #'2012-04-21T17:34:52.508+02:00') )! !

!ManifestFuelProgressUpdate classSide methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 23:00'!
ruleVariableReferencedOnceRuleV1TruePositive
^ #(#('(RGMethodDefinition className: ''FLProgressMaterializationTest'' selector: #serializeAndMaterialize: isMetaSide: false)' #'2012-04-21T23:00:30.335+02:00') )! !

FLSerialization subclass: #FLProgressSerialization
	instanceVariableNames: 'progressHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelProgressUpdate'!

!FLProgressSerialization commentStamp: '<historical>' prior: 0!
I am a subclass which notifies progress.
!

!FLProgressSerialization classSide methodsFor: 'accessing' stamp: 'MartinDias 5/7/2012 16:12'!
defaultProgressBarFactory

	self flag: #todo. "this is horrible"
	^ [ :aBlockThatNotifiesToProgressHandler | 
		'Writing to stream' 
			displayProgressAt: Sensor cursorPoint 
			from: 0 
			to: 100 
			during: [ :aBlockToValueWithProgressUpdates | 
				aBlockThatNotifiesToProgressHandler value: 
					(FLSerializationProgressHandler 
						value: aBlockToValueWithProgressUpdates 
						atMostEvery: 250) ]]! !

!FLProgressSerialization methodsFor: 'private' stamp: 'MartinDias 8/29/2011 16:48'!
clusterInstancesStepOf: aCluster

	super clusterInstancesStepOf: aCluster.
	self progressHandler serializedCluster: aCluster.! !

!FLProgressSerialization methodsFor: 'private' stamp: 'MartinDias 12/29/2011 17:03'!
headerStep

	self progressHandler serializationBegin: clusters and: encoder objectCount.
	super headerStep.! !

!FLProgressSerialization methodsFor: 'accessing' stamp: 'MartinDias 9/13/2011 18:02'!
progressHandler
	^ progressHandler! !

!FLProgressSerialization methodsFor: 'accessing' stamp: 'MartinDias 9/13/2011 18:02'!
progressHandler: anObject
	progressHandler := anObject! !

!FLProgressSerialization methodsFor: 'serializing' stamp: 'MartinDias 9/13/2011 19:57'!
run

	super run.
	self progressHandler serializationEnd.
! !
